
#ifndef _ASUS_READING_H_
#define _ASUS_READING_H_

int INIT_ASUS_READER(char *SAMPLE_XML_PATH, int debug);
void PROCESS_ASUS_READER(int debug);
void RELEASE_ASUS_READER();
int GET_WIDTH_DEPTH_ASUS_READER();
int GET_HEIGHT_DEPTH_ASUS_READER();
int GET_WIDTH_IMAGE_ASUS_READER();
int GET_HEIGHT_IMAGE_ASUS_READER();

float GET_DEPTH_ASUS_READER_AT(int index);
unsigned char GET_IMAGE_ASUS_READER_AT(int index);

#endif

// NOTE1: example on how to bypass (i.e. avoid opencv) with sup-demcare app
// NOTE2: example on how to bypass (i.e. avoid opencv) with sup-3Dwriter

//#include "../../extra/DepthCompression/asus_reading.h"

/* NOTE1
int main_with_opencv(int argc, char **argv);//, int camera_type, int buffer_size, int max_fps);
int main_without_opencv(int argc, char **argv);//, int camera_type, int buffer_size, int max_fps);
int main(int argc, char **argv)
{
//	int camera_type = 0;
//	int buffer_size = 1;
//	int max_fps = 8;
	int without_opencv=0;
	for(int i=0; i<argc; i++){
		if(strcmp(argv[i], "-without_opencv")==0) { without_opencv=1; }
	//	if(strcmp(argv[i], "-camera_type")==0) { camera_type = atoi(argv[i+1]); }
	//	if(strcmp(argv[i], "-buffer_size")==0) { buffer_size = atoi(argv[i+1]); }
	//	if(strcmp(argv[i], "-max_fps")==0) { max_fps = atoi(argv[i+1]); }
	}
	if(without_opencv==0) { return main_with_opencv(argc, argv); }//, camera_type, buffer_size, max_fps); }
	else  { return main_without_opencv(argc, argv); } //, camera_type, buffer_size, max_fps); }
}

int main_without_opencv(int argc, char **argv)//, int camera_type, int buffer_size, int max_fps);
{
	int debug = 0;
	printf("usage: ./sup-Demcare_CAR -without_opencv -config -openni\n");
	printf("e.g.\n ./sup-Demcare_CAR -without_opencv -openni ../../examples-3party/OpenNI/NiSimpleRead/SamplesConfig.xml -config ../../applications/Demcare_CAR/MINIPC_TEST_MULTICAR/\n");

	bool SAVE_VIDEO = false; char save_dir[512];
	int config=0; char config_dir[512];
	int openni_config=0; char SAMPLE_XML_PATH[512];
	for(int i=0; i<argc; i++){
		if(strcmp(argv[i], "-config")==0) { config=1; strcpy(config_dir, argv[i+1]); }
		if(strcmp(argv[i], "-save")==0) { SAVE_VIDEO=true; strcpy(save_dir, argv[i+1]); }
		if(strcmp(argv[i], "-openni")==0) { openni_config=1; strcpy(SAMPLE_XML_PATH, argv[i+1]); }
		if(strcmp(argv[i], "-debug")==0) { debug=1; }
		
	}
	if(config==0) { printf("you need to provide the parameter -config : the folder path\n"); getchar(); return -1; }
	if(openni_config==0) { printf("you need to provide parameter -openni : the SamplesConfig.xml file\n"); return -1; }

	unsigned int frameNumber = 0;
	std::string     commonPath = config_dir;//Retrieves the common path for Plugin Configuration Files
	std::cout<<"---------------------------------------------------------\n"<<enableAdjustOfPhysicalObjectsByPlanEquation<<"---------------------------------------------------------\n"<<std::endl;
	retrieveApplicationParameters(commonPath + "/appParameters.txt");
	std::cout<<"---------------------------------------------------------\n"<<enableAdjustOfPhysicalObjectsByPlanEquation<<"---------------------------------------------------------\n"<<std::endl;
	QApplication application(argc, argv);
	//dtkLogger::instance().setLevel(dtkLog::Info); // DTK Log
	dtkLogger::instance().attachConsole();// DTK Log
	dtkPluginManager::instance()->initialize(); // DTK Load Plugins
	// SUP View
	//        supView view;
	//        view.widget()->setWindowTitle("SUP View");
	//        view.show();

	//Demo view
	supViewRGBD view;
	view.widget()->setWindowTitle("Demcare");
	view.show();

	supViewEventTimeline viewEvents;
	viewEvents.init();
	viewEvents.widget()->setWindowTitle("Event timeline");
	viewEvents.show();

	//Plugin initialization
	supAbstractProcessAcquisition           * acquisitor = static_cast<supAbstractProcessAcquisition *>( dtkAbstractProcessFactory::instance()->create("opencvProcessAcquisition") );
	supAbstractProcessDepthSegmentation     * pDepthSegmentation = static_cast<supAbstractProcessDepthSegmentation *>( dtkAbstractProcessFactory::instance()->create("depthProcessSegmentation") );
	supAbstractProcessFrameToFrameTracker   * f2fTracking = static_cast<supAbstractProcessFrameToFrameTracker *>( dtkAbstractProcessFactory::instance()->create("FrameToFrameTrackerProcessFrameToFrameTracker") );
	supAbstractProcessEventRecognition      * pEventRecog = static_cast<supAbstractProcessEventRecognition *>( dtkAbstractProcessFactory::instance()->create("DescriptionBasedProcessEventRecognition") );
	supAbstractProcessDataFlowWriter        * dataFlowWriter    = NULL;
	supAbstractProcessXMLReaderWriter       * xmlWriterPlugin = static_cast< supAbstractProcessXMLReaderWriter *>( dtkAbstractProcessFactory::instance()->create("SimpleXMLReaderWriterProcessXMLReaderWriter") );
	//Initializing Calibration
	supAbstractDataCalibrationWithDepth     calibrationWithDepth;
	if(!acquisitor || !pDepthSegmentation || !pEventRecog || !f2fTracking ){
		if(!acquisitor)         { dtkInfo() << "Acquisition: "      << acquisitor; }
		if(!pDepthSegmentation) { dtkInfo() << "Segmentation: "     << pDepthSegmentation; }
		if(!f2fTracking)        { dtkInfo() << "Tracking: "         << f2fTracking; }
		if(!pEventRecog)        { dtkInfo() << "EventRecognition: " << pEventRecog; }
		dtkWarn() << "One of the plugin could not be loaded.";
		dtkPluginManager::instance()->uninitialize();
		return 1;
	}
	//Plugins initialization
	//Acquisition initialization
	QSharedPointer< supAbstractDataStream > stream(new supAbstractDataStream);
	// ASUS
	stream->device("ASUS_0");
	acquisitor->setStream( stream );
	//Data Flow Writter Variables
	int construct_buffer_size = 1; // max 1000
	int construct_camera_type = 1; // 0 kinect, 1 asus
	if(SAVE_VIDEO==true){
		QString filesPath = save_dir;//Retrieves the VideoStorage Path
		dataFlowWriter    = static_cast< supAbstractProcessDataFlowWriter * >( dtkAbstractProcessFactory::instance()->create("DepthCompressorProcessDataFlowWriter") );
		QVariantMap specific_data_flow_writer_parameters;
		getDepthWriterPluginParameters(commonPath, construct_buffer_size, construct_camera_type);
		specific_data_flow_writer_parameters.insert(QString("ConstructBufferSize"),QVariant::fromValue(int(construct_buffer_size)));
		dataFlowWriter->setFilePath(QFile(filesPath));
		// Specific parameters
		dtkTrace() << "DataFlowWriter specific parameters";
		dataFlowWriter->setSpecificParameters( specific_data_flow_writer_parameters );
	}

	//Loading Contextual Objects to display
	string l_filename = commonPath + "/DescriptionBasedEventRecognition/sup_context.xml";
	QString l_qfilename = l_filename.c_str();
	supDataContext *context = new supDataContext();
	bool result = context->read(l_qfilename);
	std::list <ContextElement> l_ListOfContextObjects;
	if(result){
		// std::cout<<"******************SUP CONTEXT OBJECT LIST******************"<<std::endl;
		l_ListOfContextObjects = context->getContext();
		//Anh-Tuan's modification/////////////////////////////
		calibrationWithDepth.read( l_qfilename );
		//////////////////////////////////////////////////////
		//Demo
		view.setContextInfo(l_ListOfContextObjects);
	}
	else{
		std::cout<<"ERROR reading the SupContext XML file.Check the filename!"<<std::endl;
	}

	//Depth Segmentation initialization
	std::string paramsFileName("paramsNew.txt");
	PhysicalObjs detectedObjs;
	pDepthSegmentation->setParameterFile(paramsFileName, commonPath+"/depthSegmentation/");
	//loading calibration
	pDepthSegmentation->setCalibrationWithDepth( &calibrationWithDepth );
	if(context->getContext().size()>0){
		//Computing the floor plan through Contextual Objects
		pDepthSegmentation->computeEquationPlan( context );
	}
	// Tracking initialization
	std::string paramsFileNameTracking("/paramTracking.txt");
	f2fTracking->setParameterFile( paramsFileNameTracking, commonPath + "/f2fTracking/" );
	//Event Recognition Initialization
	pEventRecog->setParameterFile(commonPath  + "/DescriptionBasedEventRecognition/EventRecognitionParameters.xml");
	pEventRecog->setCommonFilePath(commonPath + "/DescriptionBasedEventRecognition/");
	pEventRecog->init();
	//Depth Segmentation Initialization
	//XML1 Generator initialization
	//xmlWriterPlugin->setXML(commonPath + "/DescriptionBasedEventRecognition/xml1.xml");
	int tolerance   = 0;
	//        cv::Mat depthMap;
	cv::Mat bgrImage(480, 640, CV_8UC3);
	cv::Mat depthMap(480, 640, CV_32F);//CV_8UC3);
	//Event Summary Configuration
	std::string timeRef = createStringFromCurrentTime();
	std::string     p_l_fileNameToReadTemplate = commonPath + "/EventSummary/" + "templateEvents.txt";
	std::string     l_EventSummaryFileName;
	if(l_PathEventSummary.compare("")==0)
		l_EventSummaryFileName = commonPath + "/EventSummary/";
	else
		l_EventSummaryFileName = l_PathEventSummary;
	l_EventSummaryFileName +=  "Patient_" + timeRef + "_sum.html";
	QDateTime startingTime = QDateTime::currentDateTime();
	
	if(INIT_ASUS_READER(SAMPLE_XML_PATH, debug)!=0) { return 0; }

	while(view.widget()->isVisible())
	{
		std::cout<<std::endl<<"....................................................................................FRAME:"<<frameNumber<<std::endl;
		dtkDebug() << "Image getting acquired.";
		acquisitor->acquire();
		
		if(debug==1) { printf(" -- DEBUG -- 1\n"); }
		PROCESS_ASUS_READER(debug);
		int cnt=0;
		for(int i = 0; i < 480; i++){
			for(int j = 0; j < 640; j++){
				depthMap.at<float>(i,j) = (float)(GET_DEPTH_ASUS_READER_AT(cnt))*1000.0f; cnt++;
			}
		}
		cnt=0;
		for(int i = 0; i < 480; i++){
			for(int j = 0; j < 640; j++){
				bgrImage.at<cv::Vec3b>(i,j)[2] = GET_IMAGE_ASUS_READER_AT(cnt); cnt++;
				bgrImage.at<cv::Vec3b>(i,j)[1] = GET_IMAGE_ASUS_READER_AT(cnt); cnt++;
				bgrImage.at<cv::Vec3b>(i,j)[0] = GET_IMAGE_ASUS_READER_AT(cnt); cnt++;
			}
		}
		if(debug==1) { printf(" -- DEBUG -- 2\n"); }
	//	supDataImage supdepth; supdepth.setImage(depthMap);
	//	supDataImage supimage; supimage.setImage(bgrImage);
		acquisitor->setImage(bgrImage);//supimage);
		acquisitor->setDepth(depthMap);
		/// HOW ????????????? QSharedPointer< supDataImage > m_supimage = &(supimage);

	//	QSharedPointer< supDataImage > image; image->setImage(bgrImage);
     //   QSharedPointer< supDataImage > depth; depth->setImage(depthMap);

//supDataImage supdepth;
//image->data() = supdepth;
		
		//Perform People Detection Tracking and Event Recogni
		if(debug==1) { printf(" -- DEBUG -- 3\n"); }
		detectedObjs.clear();
		if(debug==1) { printf(" -- DEBUG -- 4\n"); }
		pDepthSegmentation->setSynchronizer(acquisitor->getSynchronizer() );
		if(debug==1) { printf(" -- DEBUG -- 5\n"); }
		pDepthSegmentation->setColorImg(*acquisitor->getImage()); //		pDepthSegmentation->setColorImg(supimage);// &(image->data()));//supimage);// *acquisitor->getImage() );
		if(debug==1) { printf(" -- DEBUG -- 6\n"); }
		pDepthSegmentation->setDepthImg(*acquisitor->getDepth()); //pDepthSegmentation->setDepthImg(sudepth);//depth->d);//supdepth);// *acquisitor->getDepth() );
		if(debug==1) { printf(" -- DEBUG -- 7\n"); }
		pDepthSegmentation->getPhysicalObjs( detectedObjs );
		if(debug==1) { printf(" -- DEBUG -- 7a\n"); }
		SpLinkedPhysicalObjectList o_linkedPhysicalObjects;
		if(debug==1) { printf(" -- DEBUG -- 7b\n"); }
		std::list <QSharedPointer < supDataActor > > p_actors_t;
		if(debug==1) { printf(" -- DEBUG -- 7c\n"); }
		std::list <QSharedPointer <const supDataActor > > actors;
		if(debug==1) { printf(" -- DEBUG -- 7d\n"); }
		f2fTracking->setSynchronizer( pDepthSegmentation->getSynchronizer() );
		if(debug==1) { printf(" -- DEBUG -- 8\n"); }
		f2fTracking->apply(*acquisitor->getImage(), detectedObjs, o_linkedPhysicalObjects);
		if(debug==1) { printf(" -- DEBUG -- 9\n"); }
		f2fTracking->applyLTT(o_linkedPhysicalObjects, p_actors_t);

		if(debug==1) { printf(" -- DEBUG -- 10\n"); }
		std::list <QSharedPointer < supDataActor > >::const_iterator it;
		for (it = p_actors_t.begin(); it != p_actors_t.end(); it++){
			actors.push_back(*it);
		}

		//event recognition process
		if(debug==1) { printf(" -- DEBUG -- 11\n"); }
		pEventRecog->setActors(actors);
		if(debug==1) { printf(" -- DEBUG -- 11 a\n"); }
		pEventRecog->setSynchronizer( f2fTracking->getSynchronizer() );
		if(debug==1) { printf(" -- DEBUG -- 11 b\n"); }
		pEventRecog->performEventRecognition();
		if(debug==1) { printf(" -- DEBUG -- 11 c\n"); }
		if(SAVE_VIDEO==true)
		{
			if(debug==1) { printf(" -- DEBUG -- 11 S\n"); }
			tolerance--;
			if(actors.size()>0 || tolerance > 0 ){
				QList < QSharedPointer< supAbstractData > > dataFlow;
				dataFlow.push_back(acquisitor->getDepth());
				dataFlow.push_back(acquisitor->getImage());
				dataFlowWriter->setSynchronizer(acquisitor->getSynchronizer());
				dataFlowWriter->setDataFlow(dataFlow);
				// Process
				dtkTrace() << "DataFlowWriter process";
				dataFlowWriter->writeDataFlow();
				if(actors.size()>0)
					tolerance = 50;
			}
		}

		//Demo visualization
		if(debug==1) { printf(" -- DEBUG -- 12\n"); }
		std::list< QSharedPointer<supDataEvent> > l_currentFrameEvents;

		if(debug==1) { printf(" -- DEBUG -- 13\n"); }
		l_currentFrameEvents =  pEventRecog->getCurrentFrameEvents();

		if(debug==1) { printf(" -- DEBUG -- 14\n"); }
		viewEvents.setEvents(l_currentFrameEvents);
		viewEvents.updateDisplay();

		if(debug==1) { printf(" -- DEBUG -- 15\n"); }
		view.setAcquisitionImage(acquisitor->getImage());
		view.setAcquisitionDepth(acquisitor->getDepth());
		view.setActors(actors);
		view.setEvents(l_currentFrameEvents);
		view.updateDisplay();

		if(debug==1) { printf(" -- DEBUG -- 16\n"); }
		if(l_EnableEventSummaryGeneration){
			manageEventSummary( l_currentFrameEvents, p_l_fileNameToReadTemplate, l_EventSummaryFileName, g_SummaryGenerationTriggerEvent);
		}

		if(debug==1) { printf(" -- DEBUG -- 17\n"); }
		std::string actorXML;
		actorXML = xmlWriterPlugin->getFrameDataAsXML( actors, f2fTracking->getSynchronizer() );

		//Event data storage generation
		if(debug==1) { printf(" -- DEBUG -- 18\n"); }
		std::string eventXML =   pEventRecog->generateEventListStorageStream();

		//DB storage generation
		if(debug==1) { printf(" -- DEBUG -- 19\n"); }
		if(enableDbStorage){
			if(debug==1) { printf(" -- DEBUG -- 19b\n"); }
			dbStore(actorXML, eventXML);
		}

		if(debug==1) { printf(" -- DEBUG -- 20\n"); }
		if(enableEventStreaming){
			if(debug==1) { printf(" -- DEBUG -- 20b\n"); }
			manageEventStreaming(l_currentFrameEvents);
		}

		if(debug==1) { printf(" -- DEBUG -- 21\n"); }
		application.processEvents();
		++frameNumber;
		if(debug==1) { printf(" -- DEBUG -- 22\n"); }
		l_currentFrameEvents.clear();
	}

	//Creating Event Summary
	std::cout<<"\n Chain computation:";
	std::cout<<"\nStart time:"<<startingTime.toString().toStdString()<<", End time:"<<startingTime.currentDateTime().toString().toStdString()<<std::endl;
	std::cout<<"\n Summary computation:";
	mergeAndSummarizeRemainingEvents(p_l_fileNameToReadTemplate, l_EventSummaryFileName);
	std::cout<<"\nStart time:"<<startingTime.toString().toStdString()<<", End time:"<<startingTime.currentDateTime().toString().toStdString()<<std::endl;
	delete pEventRecog;
	dtkPluginManager::instance()->uninitialize();
	
	return 0;
}

int main_with_opencv(int argc, char **argv)//, int camera_type, int buffer_size, int max_fps);
{
    //argv[1]: Config Files Folder
    //argv[2]: Video storage path
	int debug = 1;
    if(argc<2){

        std::cout<<"You need to provide the path to the configuration files <An example is available in this example source-code folder>\n";

    }else{
	  
        //Application variables and parameters initialization

        unsigned int frameNumber = 0;

        bool SAVE_VIDEO = false;

        if(argc>2) { SAVE_VIDEO=true;}

        std::string     commonPath = argv[1];//Retrieves the common path for Plugin Configuration Files

        std::cout<<"---------------------------------------------------------\n"<<enableAdjustOfPhysicalObjectsByPlanEquation<<"---------------------------------------------------------\n"<<std::endl;

        retrieveApplicationParameters(commonPath + "/appParameters.txt");


        std::cout<<"---------------------------------------------------------\n"<<enableAdjustOfPhysicalObjectsByPlanEquation<<"---------------------------------------------------------\n"<<std::endl;

        QApplication application(argc, argv);

        // DTK Log
        dtkLogger::instance().setLevel(dtkLog::Info);
        dtkLogger::instance().attachConsole();

        // DTK Load Plugins
        dtkPluginManager::instance()->initialize();

        // SUP View
//        supView view;
//        view.widget()->setWindowTitle("SUP View");
//        view.show();

        //Demo view
        supViewRGBD view;
        view.widget()->setWindowTitle("Demcare");
        view.show();

        supViewEventTimeline viewEvents;
        viewEvents.init();
        viewEvents.widget()->setWindowTitle("Event timeline");
        viewEvents.show();


        //Plugin initialization

        supAbstractProcessAcquisition           * acquisitor = static_cast<supAbstractProcessAcquisition *>( dtkAbstractProcessFactory::instance()->create("opencvProcessAcquisition") );

        supAbstractProcessDepthSegmentation     * pDepthSegmentation = static_cast<supAbstractProcessDepthSegmentation *>( dtkAbstractProcessFactory::instance()->create("depthProcessSegmentation") );

        supAbstractProcessFrameToFrameTracker   * f2fTracking = static_cast<supAbstractProcessFrameToFrameTracker *>( dtkAbstractProcessFactory::instance()->create("FrameToFrameTrackerProcessFrameToFrameTracker") );

        supAbstractProcessEventRecognition      * pEventRecog = static_cast<supAbstractProcessEventRecognition *>( dtkAbstractProcessFactory::instance()->create("DescriptionBasedProcessEventRecognition") );

        supAbstractProcessDataFlowWriter        * dataFlowWriter    = NULL;

        supAbstractProcessXMLReaderWriter       * xmlWriterPlugin = static_cast< supAbstractProcessXMLReaderWriter *>( dtkAbstractProcessFactory::instance()->create("SimpleXMLReaderWriterProcessXMLReaderWriter") );

        //Initializing Calibration
        supAbstractDataCalibrationWithDepth     calibrationWithDepth;

        if(!acquisitor || !pDepthSegmentation || !pEventRecog || !f2fTracking )
        {
            if(!acquisitor)         { dtkInfo() << "Acquisition: "      << acquisitor; }
            if(!pDepthSegmentation) { dtkInfo() << "Segmentation: "     << pDepthSegmentation; }
            if(!f2fTracking)        { dtkInfo() << "Tracking: "         << f2fTracking; }
            if(!pEventRecog)        { dtkInfo() << "EventRecognition: " << pEventRecog; }

            dtkWarn() << "One of the plugin could not be loaded.";

            dtkPluginManager::instance()->uninitialize();

            return 1;
        }

        //Plugins initialization

        //Acquisition initialization
        QSharedPointer< supAbstractDataStream > stream(new supAbstractDataStream);

        // ASUS
        stream->device("ASUS_0");
        acquisitor->setStream( stream );

        //Data Flow Writter Variables
        int construct_buffer_size = 1; // max 1000
        int construct_camera_type = 1; // 0 kinect, 1 asus

        if(SAVE_VIDEO==true){

            QString filesPath = argv[2];//Retrieves the VideoStorage Path

            dataFlowWriter    = static_cast< supAbstractProcessDataFlowWriter * >( dtkAbstractProcessFactory::instance()->create("DepthCompressorProcessDataFlowWriter") );

            QVariantMap specific_data_flow_writer_parameters;

			//printf("construct_buffer_size %d\n", construct_buffer_size); getchar();
            getDepthWriterPluginParameters(commonPath, construct_buffer_size, construct_camera_type);

			//printf("construct_buffer_size %d\n", construct_buffer_size); getchar();
            specific_data_flow_writer_parameters.insert(QString("ConstructBufferSize"),QVariant::fromValue(int(construct_buffer_size)));

            dataFlowWriter->setFilePath(QFile(filesPath));

            // Specific parameters
            dtkTrace() << "DataFlowWriter specific parameters";
            dataFlowWriter->setSpecificParameters( specific_data_flow_writer_parameters );
        }

        //Loading Contextual Objects to display
        string l_filename = commonPath + "/DescriptionBasedEventRecognition/sup_context.xml";

        QString l_qfilename = l_filename.c_str();

        supDataContext *context = new supDataContext();
        bool result = context->read(l_qfilename);

        std::list <ContextElement> l_ListOfContextObjects;

        if(result)
        {
           // std::cout<<"******************SUP CONTEXT OBJECT LIST******************"<<std::endl;
            l_ListOfContextObjects = context->getContext();

            //Anh-Tuan's modification/////////////////////////////
            calibrationWithDepth.read( l_qfilename );
            //////////////////////////////////////////////////////

            //Demo
            view.setContextInfo(l_ListOfContextObjects);
        }
        else
        {
            std::cout<<"ERROR reading the SupContext XML file.Check the filename!"<<std::endl;
        }

        //Depth Segmentation initialization
        std::string paramsFileName("paramsNew.txt");

        PhysicalObjs detectedObjs;

        pDepthSegmentation->setParameterFile(paramsFileName, commonPath+"/depthSegmentation/");

        //loading calibration
        pDepthSegmentation->setCalibrationWithDepth( &calibrationWithDepth );

        if(context->getContext().size()>0 ){
            //Computing the floor plan through Contextual Objects
            pDepthSegmentation->computeEquationPlan( context );
        }

        // Tracking initialization
        std::string paramsFileNameTracking("/paramTracking.txt");
        f2fTracking->setParameterFile( paramsFileNameTracking, commonPath + "/f2fTracking/" );

        //Event Recognition Initialization
        pEventRecog->setParameterFile(commonPath  + "/DescriptionBasedEventRecognition/EventRecognitionParameters.xml");

        pEventRecog->setCommonFilePath(commonPath + "/DescriptionBasedEventRecognition/");

        pEventRecog->init();

        //Depth Segmentation Initialization


        //XML1 Generator initialization
        //xmlWriterPlugin->setXML(commonPath + "/DescriptionBasedEventRecognition/xml1.xml");

        int tolerance   = 0;

//        cv::Mat depthMap;
        cv::Mat bgrImage;

        //Event Summary Configuration

        std::string timeRef = createStringFromCurrentTime();

        std::string     p_l_fileNameToReadTemplate = commonPath + "/EventSummary/" + "templateEvents.txt";
        std::string     l_EventSummaryFileName;

        if(l_PathEventSummary.compare("")==0)
            l_EventSummaryFileName = commonPath + "/EventSummary/";
        else
            l_EventSummaryFileName = l_PathEventSummary;

        l_EventSummaryFileName +=  "Patient_" + timeRef + "_sum.html";

        QDateTime startingTime = QDateTime::currentDateTime();

        while(view.widget()->isVisible()){

            std::cout<<std::endl<<"....................................................................................FRAME:"<<frameNumber<<std::endl;

            dtkDebug() << "Image getting acquired.";

            acquisitor->acquire();

            bgrImage = acquisitor->getImage()->getImage();//Changed

            //Perform People Detection Tracking and Event Recogni
            detectedObjs.clear();
            pDepthSegmentation->setSynchronizer(acquisitor->getSynchronizer() );
            pDepthSegmentation->setColorImg( *acquisitor->getImage() );
            pDepthSegmentation->setDepthImg( *acquisitor->getDepth() );

            pDepthSegmentation->getPhysicalObjs( detectedObjs );

//            if(context->getContext().size()>1 && enableAdjustOfPhysicalObjectsByPlanEquation){

//                pDepthSegmentation->adjustBoundingBox3d( detectedObjs );

//            }

            SpLinkedPhysicalObjectList o_linkedPhysicalObjects;
            std::list <QSharedPointer < supDataActor > > p_actors_t;
            std::list <QSharedPointer <const supDataActor > > actors;

            f2fTracking->setSynchronizer( pDepthSegmentation->getSynchronizer() );

            f2fTracking->apply(*acquisitor->getImage(), detectedObjs, o_linkedPhysicalObjects);
            f2fTracking->applyLTT(o_linkedPhysicalObjects, p_actors_t);


            std::list <QSharedPointer < supDataActor > >::const_iterator it;
            for (it = p_actors_t.begin(); it != p_actors_t.end(); it++){
                actors.push_back(*it);
            }

            //event recognition process

            pEventRecog->setActors(actors);

            pEventRecog->setSynchronizer( f2fTracking->getSynchronizer() );

            pEventRecog->performEventRecognition();

            if(SAVE_VIDEO==true){
                tolerance--;

                if(actors.size()>0 || tolerance > 0 ){

					if(debug==1) { printf(" .. saving - dataflow pointer\n"); }
                    QList < QSharedPointer< supAbstractData > > dataFlow;
					
					if(debug==1) { printf(" .. saving - getdepth\n"); }
                    dataFlow.push_back(acquisitor->getDepth());

					if(debug==1) { printf(" .. saving - get image \n"); }
                    dataFlow.push_back(acquisitor->getImage());

					if(debug==1) { printf(" .. saving - set synchronizer\n"); }
                    dataFlowWriter->setSynchronizer(acquisitor->getSynchronizer());

					if(debug==1) { printf(" .. saving - set dataflow\n"); }
                    dataFlowWriter->setDataFlow(dataFlow);

                    // Process
                    dtkTrace() << "DataFlowWriter process";
					if(debug==1) { printf(" .. saving - write data flow\n"); }
                    dataFlowWriter->writeDataFlow();

                    if(actors.size()>0)
                        tolerance = 50;
					
					if(debug==1) { printf(" .. saving - done\n"); }
                }
            }

            //Demo visualization
            std::list< QSharedPointer<supDataEvent> > l_currentFrameEvents;

            l_currentFrameEvents =  pEventRecog->getCurrentFrameEvents();

            viewEvents.setEvents(l_currentFrameEvents);
            viewEvents.updateDisplay();

            view.setAcquisitionImage(acquisitor->getImage());
            view.setAcquisitionDepth(acquisitor->getDepth());
            view.setActors(actors);
            view.setEvents(l_currentFrameEvents);
            view.updateDisplay();

            if(l_EnableEventSummaryGeneration){

                manageEventSummary( l_currentFrameEvents, p_l_fileNameToReadTemplate, l_EventSummaryFileName, g_SummaryGenerationTriggerEvent);

            }

            std::string actorXML;

            actorXML = xmlWriterPlugin->getFrameDataAsXML( actors, f2fTracking->getSynchronizer() );

            //Event data storage generation
            std::string eventXML =   pEventRecog->generateEventListStorageStream();

            //DB storage generation
            if(enableDbStorage){
                dbStore(actorXML, eventXML);
            }

            //alert generation (not needed for now)
//             if(enableEventStreaming){
//                 std::string msg = pEventRecog->generateEventListStreamToNotify();

//                 if(msg.compare("")!=0){
//                     //sendMsg(msg, argv[2], argv[3]);
//                     std::cout<<std::endl<<"Sending MSG:"<<msg<<std::endl;
//                     sendMsg(msg, EventStreamingSocketConnectionURL , EventStreamingSocketConnectionPort);

//                 }
//             }

            if(enableEventStreaming){
                manageEventStreaming(l_currentFrameEvents);
            }

            application.processEvents();

            ++frameNumber;

            l_currentFrameEvents.clear();

        }

        //Creating Event Summary


        std::cout<<"\n Chain computation:";
        std::cout<<"\nStart time:"<<startingTime.toString().toStdString()<<", End time:"<<startingTime.currentDateTime().toString().toStdString()<<std::endl;

        std::cout<<"\n Summary computation:";

        mergeAndSummarizeRemainingEvents(p_l_fileNameToReadTemplate, l_EventSummaryFileName);

        std::cout<<"\nStart time:"<<startingTime.toString().toStdString()<<", End time:"<<startingTime.currentDateTime().toString().toStdString()<<std::endl;

//        std::list< QSharedPointer<supDataEvent> > ListOfEvent = pEventRecog->getAllFramesEvents();

//        std::string timeStampRef = createStringFromCurrentTime();

        //std::string     fileName = commonPath + "/EventSummary/" + "Patient_" + timeRef + "_sum.csv";
    //std::string     fileName = commonPath + "/EventSummary/" + "Patient_" + timeStampRef + "_sum.csv";
//        std::string     fileName = commonPath + "/EventSummary/" + "Patient_" + timeStampRef + "_sum.html";
  
//	std::string     fileNameToReadTemplate = commonPath + "/EventSummary/" + "templateEvents.txt";


//        map<int, double> actorEventDuration;

//        map<int, std::map< std::string, TOccurrences> > l_setOfSummaries =   generateEventSummary(ListOfEvent);

//        computeActorEventTime(ListOfEvent, actorEventDuration);

//        std::cout<<std::endl<<"ThresholdTORemoveActors:"<<l_ActorMinimumEventTimeForSummaryGeneration<<", MergeResults?:"<<l_EnableEventSummaryMerge<<";";

//        removeEventActorsLowEventTotalTime(actorEventDuration, l_ActorMinimumEventTimeForSummaryGeneration, l_setOfSummaries);

//        if(l_EnableEventSummaryMerge){

//            map<  int, std::map< std::string, TOccurrences> >  l_mergeSummary = mergeEventSummary(l_setOfSummaries);

            //writeEventSummaryIntoCSVFile(l_mergeSummary, fileNameToReadTemplate, fileName);
//            writeEventSummaryIntoHTMLFile(l_mergeSummary, fileNameToReadTemplate, fileName);

//        }else{

           //writeEventSummaryIntoCSVFile(l_setOfSummaries, fileNameToReadTemplate, fileName);
//            writeEventSummaryIntoHTMLFile(l_setOfSummaries, fileNameToReadTemplate, fileName);

//        }

//        map< int, double >::iterator it_actor;

//        for(it_actor = actorEventDuration.begin(); it_actor!= actorEventDuration.end(); it_actor++){

//            std::cout<<endl<<it_actor->first<<": "<<it_actor->second<<endl;

//        }

        //memory release
//        l_setOfSummaries.clear();

//        actorEventDuration.clear();

//        ListOfEvent.clear();

        delete pEventRecog;
        dtkPluginManager::instance()->uninitialize();

    }
    return 0;
}
*/
/*
/// NOTE2
int main_with_opencv(int argc, char **argv, int camera_type, int buffer_size, int max_fps);
int main_without_opencv(int argc, char **argv, int camera_type, int buffer_size, int max_fps);
int main(int argc, char **argv)
{
	printf("usage: ./sup-3DSensor_writer -without_opencv (if your opencv lib is not compiled with openni) -directory where_files_will_be_recorded -config complete_path_of_the_SamplesConfig.xml -camera_type (integer: 0 asus 1 kinect) -buffer_size (integer: by default 1) -max_fps (integer: maximum frame per second: minimum 1)\n");
	int camera_type = 0;
	int buffer_size = 1;
	int max_fps = 8;
	int without_opencv=0;
	for(int i=0; i<argc; i++){
		if(strcmp(argv[i], "-without_opencv")==0) { without_opencv=1; }
		if(strcmp(argv[i], "-camera_type")==0) { camera_type = atoi(argv[i+1]); }
		if(strcmp(argv[i], "-buffer_size")==0) { buffer_size = atoi(argv[i+1]); }
		if(strcmp(argv[i], "-max_fps")==0) { max_fps = atoi(argv[i+1]); }
	}
	if(without_opencv==0) { return main_with_opencv(argc, argv, camera_type, buffer_size, max_fps); }
	else  { return main_without_opencv(argc, argv, camera_type, buffer_size, max_fps); }
}

int main_with_opencv(int argc, char **argv, int camera_type, int buffer_size, int max_fps)
{
	int debug=0;
    QApplication application(argc, argv);

    //! DTK Log
    dtkLogger::instance().setLevel(dtkLog::Info);
    dtkLogger::instance().attachConsole();

    //! DTK Load Plugins
    dtkPluginManager::instance()->initialize();


    //! Initialization
    // SUP Abstract Data Stream
    QSharedPointer< supAbstractDataStream > spStream (new supAbstractDataStream);

    // URL Parameter for the AbstractDataStream
    // Kinect device
	if(camera_type==0) { spStream->device("ASUS_0"); } // Asus device
    else { spStream->device("KINECT_0"); }
  


    supAbstractProcessAcquisition* acquisitor = static_cast< supAbstractProcessAcquisition *>( dtkAbstractProcessFactory::instance()->create("opencvProcessAcquisition") );

    QVariantMap specific_data_flow_writer_parameters;
    specific_data_flow_writer_parameters.insert(QString("ConstructBufferSize"),QVariant::fromValue(int(buffer_size))); //50

    supAbstractProcessDataFlowWriter *  data_flow_writer    = static_cast< supAbstractProcessDataFlowWriter * >( dtkAbstractProcessFactory::instance()->create("DepthCompressorProcessDataFlowWriter") );

    if(!acquisitor || !data_flow_writer)
    {
        if(!acquisitor)       { dtkInfo() << "Acquisition: "        << acquisitor; }
        if(!data_flow_writer)       { dtkInfo() << "DataFlowWriter: "     << data_flow_writer; }

        dtkWarn() << "One of the plugin could not be loaded.";

        dtkPluginManager::instance()->uninitialize();
        return 1;
    }

    // SUP View
    supView view;
    view.widget()->setWindowTitle("SUP View");
    view.show();
	
//	data_flow_writer->buffer_size=buffer_size;
//	data_flow_writer->camera_type=camera_type;
//	data_flow_writer->max_fps=max_fps;

    while( view.widget()->isVisible() )
    {
        //! Acquisition
        // Inputs
        dtkTrace() << "Acquisition input";
		if(debug==1) { printf(" - DEBUG - setStream\n"); }
        acquisitor->setStream( spStream );

        // Process
        dtkTrace() << "Acquisition process";
		if(debug==1) { printf(" - DEBUG - acquire\n"); }
        acquisitor->acquire();

        // Check Synchronizer
		if(debug==1) { printf(" - DEBUG - info\n"); }
        dtkInfo() << "QDateTime from application: " << acquisitor->getSynchronizer().getDateTime();

        // Display
        dtkTrace() << "Acquisition display";
		if(debug==1) { printf(" - DEBUG - set display\n"); }
        view.setAcquisitionImage( acquisitor->getImage() );

        //! DataFlowWriter
        QList< QSharedPointer< supAbstractData > > dataFlow;
		if(debug==1) { printf(" - DEBUG - dataflow depth\n"); }
        dataFlow.push_back(acquisitor->getDepth());
		if(debug==1) { printf(" - DEBUG - dataFlow image\n"); }
        dataFlow.push_back(acquisitor->getImage());

        // Inputs
        dtkTrace() << "DataFlowWriter inputs";
		if(debug==1) { printf(" - DEBUG - set synchro\n"); }
        data_flow_writer->setSynchronizer(acquisitor->getSynchronizer());
		if(debug==1) { printf(" - DEBUG - set flow\n"); }
        data_flow_writer->setDataFlow( dataFlow );
		if(debug==1) { printf(" - DEBUG - set file path\n"); }
        data_flow_writer->setFilePath(QFile(argv[1]));

        // Specific parameters
        dtkTrace() << "DataFlowWriter specific parameters";
		if(debug==1) { printf(" - DEBUG - set specific param\n"); }
        data_flow_writer->setSpecificParameters( specific_data_flow_writer_parameters );

        // Process
        dtkTrace() << "DataFlowWriter process";
		if(debug==1) { printf(" - DEBUG - write\n"); }
        data_flow_writer->writeDataFlow();

		if(debug==1) { printf(" - DEBUG - processEvents\n"); }
        application.processEvents();
    }

    dtkPluginManager::instance()->uninitialize();
    return 0;
}

int main_without_opencv(int argc, char **argv, int camera_type, int buffer_size, int max_fps)
{
	printf("./sup-3DSensor_writer -without_opencv -config ../../examples-3party/OpenNI/NiSimpleRead/SamplesConfig.xml -directory /home/ecorvee/temp-sup/\n");
  
	int debug=0;
	int display=0;
	int directory_succ=0; char directory[512];
	int config=0; char SAMPLE_XML_PATH[512];
	for(int i=0; i<argc; i++){
		if(strcmp(argv[i], "-debug")==0) { debug=1; }
		if(strcmp(argv[i], "-display")==0) { display=1; }
		if(strcmp(argv[i], "-directory")==0) { directory_succ=1; strcpy(directory, argv[i+1]); }
		if(strcmp(argv[i], "-config")==0) { config=1; strcpy(SAMPLE_XML_PATH, argv[i+1]); }
	}
	if(config==0) { printf("ERROR -config file path and name not provided\n"); return -1; }
	if(directory_succ==0) { printf("ERROR -directory path not provided\n"); return -1; }
	
	
	if(debug==1) { printf("these param are chosen camera_type %d, buffer_size %d, max_fps %d\n", camera_type, buffer_size, max_fps); getchar(); }
	
	
	
	if(debug==1) { printf(" - DEBUG - 1\n"); }
    QApplication application(argc, argv);

    //! DTK Log
	if(debug==1) { printf(" - DEBUG - 2\n"); }
    //dtkLogger::instance().setLevel(dtkLog::Info);
    dtkLogger::instance().attachConsole();

    //! DTK Load Plugins
	if(debug==1) { printf(" - DEBUG - 3\n"); }
    dtkPluginManager::instance()->initialize();


    //! Initialization
    // SUP Abstract Data Stream
	if(debug==1) { printf(" - DEBUG - 4\n"); }
    QSharedPointer< supAbstractDataStream > spStream (new supAbstractDataStream);

    // URL Parameter for the AbstractDataStream
    // Kinect device
    //spStream->device("KINECT_0");
    // Asus device
	if(debug==1) { printf(" - DEBUG - 5\n"); }
    spStream->device("ASUS_0");

	if(debug==1) { printf(" - DEBUG - 6\n"); }
    supAbstractProcessAcquisition* acquisitor = static_cast< supAbstractProcessAcquisition *>( dtkAbstractProcessFactory::instance()->create("opencvProcessAcquisition") );

	if(debug==1) { printf(" - DEBUG - 7\n"); }
    QVariantMap specific_data_flow_writer_parameters;
    specific_data_flow_writer_parameters.insert(QString("ConstructBufferSize"),QVariant::fromValue(int(50)));

	if(debug==1) { printf(" - DEBUG - 8\n"); }
    supAbstractProcessDataFlowWriter *  data_flow_writer    = static_cast< supAbstractProcessDataFlowWriter * >( dtkAbstractProcessFactory::instance()->create("DepthCompressorProcessDataFlowWriter") );

	if(debug==1) { printf(" - DEBUG - 9\n"); }
    if(!acquisitor || !data_flow_writer)
    {
        if(!acquisitor)       { dtkInfo() << "Acquisition: "        << acquisitor; }
        if(!data_flow_writer)       { dtkInfo() << "DataFlowWriter: "     << data_flow_writer; }

        dtkWarn() << "One of the plugin could not be loaded.";

        dtkPluginManager::instance()->uninitialize();
        return 1;
    }

    // SUP View
    if(debug==1) { printf(" - DEBUG - 10\n"); }
    supView view;
    view.widget()->setWindowTitle("SUP View");
    view.show();
	
	
	
	
	
	
	
	
	
	if(INIT_ASUS_READER(SAMPLE_XML_PATH, debug)!=0) { return 0; }
	EC_RGBD_CameraCompression3 camera_depth;
 	EC_RGBD_CameraCompression3_parameters parameters;
 	parameters.SetWriteMode();
 	parameters.SetCameraType(camera_type);// 0 kinect, 1 asus camera_type);
 	parameters.SetSizeBuffer(buffer_size);//1000);
 	printf("INFO - buffer_size %d, camera_type %d, PRESS to continue\n", buffer_size, camera_type); //getchar();
 	parameters.SetDirectory((char *)(directory));//[1]));
 	parameters.SetDepthStem((char *)("depth")); // nb frames per sub dir
 	parameters.SetBGRStem((char *)("bgrimage"));
 	parameters.SetMaxFPS((float)(max_fps));
 	camera_depth.Construct(parameters);
	
	cv::Mat bgrImage(480, 640, CV_8UC3);
	
	if(debug==1) { printf(" - DEBUG - loop\n"); }
    while( view.widget()->isVisible() )
    {
		acquisitor->acquire();
		
		PROCESS_ASUS_READER(debug);

		printf("%d x %d, %d x %d\n", GET_HEIGHT_DEPTH_ASUS_READER(), GET_WIDTH_DEPTH_ASUS_READER(), GET_HEIGHT_IMAGE_ASUS_READER(), GET_WIDTH_IMAGE_ASUS_READER());
		
		int index=0;
		for(int row=0; row<GET_HEIGHT_DEPTH_ASUS_READER(); row++){
			for(int col=0; col<GET_WIDTH_DEPTH_ASUS_READER(); col++){
				//camera_depth.DepthMap[index] = reader.DepthMap[index]; index++;
				camera_depth.DepthMap[index] = GET_DEPTH_ASUS_READER_AT(index); index++;
			}
		}
		index=0;
		for(int row=0; row<GET_HEIGHT_IMAGE_ASUS_READER(); row++){
			for(int col=0; col<GET_WIDTH_IMAGE_ASUS_READER(); col++){
			//	camera_depth.ColourImage[index] = reader.ColourImage[index]; index++;
			//	camera_depth.ColourImage[index] = reader.ColourImage[index]; index++;
			//	camera_depth.ColourImage[index] = reader.ColourImage[index]; index++;
				camera_depth.ColourImage[index] = GET_IMAGE_ASUS_READER_AT(index); index++;
				camera_depth.ColourImage[index] = GET_IMAGE_ASUS_READER_AT(index); index++;
				camera_depth.ColourImage[index] = GET_IMAGE_ASUS_READER_AT(index); index++;
			}
		}
		  
		  
		  
		  
		  
		// for display
		int cnt=0;
		for(int i = 0; i < 480; i++){
			for(int j = 0; j < 640; j++){
				bgrImage.at<cv::Vec3b>(i,j)[2] = GET_IMAGE_ASUS_READER_AT(cnt); cnt++;
				bgrImage.at<cv::Vec3b>(i,j)[1] = GET_IMAGE_ASUS_READER_AT(cnt); cnt++;
				bgrImage.at<cv::Vec3b>(i,j)[0] = GET_IMAGE_ASUS_READER_AT(cnt); cnt++;
			}
		}
		supDataImage supimage; supimage.setImage(bgrImage);
		acquisitor->setImage(bgrImage);//supimage);
		  
		  
		  
	  	
		bool RECORD_NOW = true;
		
		camera_depth.apply_with_timestamp(
			RECORD_NOW, 
			acquisitor->getSynchronizer().getFrameNumber()-1, 
			acquisitor->getSynchronizer().getYear(), acquisitor->getSynchronizer().getMonth(), acquisitor->getSynchronizer().getDay(), acquisitor->getSynchronizer().getHour(), acquisitor->getSynchronizer().getMinute(),acquisitor->getSynchronizer().getSecond(), acquisitor->getSynchronizer().getMillisecond(), debug);
		
		
		printf(" %d, %d %d %d, %d %d %d, %d\n", acquisitor->getSynchronizer().getFrameNumber()-1, 
			acquisitor->getSynchronizer().getYear(), acquisitor->getSynchronizer().getMonth(), acquisitor->getSynchronizer().getDay(), acquisitor->getSynchronizer().getHour(), acquisitor->getSynchronizer().getMinute(), acquisitor->getSynchronizer().getSecond(), acquisitor->getSynchronizer().getMillisecond());
		if(debug==1) { getchar(); }
		
		
		
		
		
        //! Acquisition
        // Inputs
		//dtkTrace() << "Acquisition input";
        //acquisitor->setStream( spStream );
	
		//XnStatus nRetVal = context.WaitOneUpdateAll(depth);

        // Process
        //dtkTrace() << "Acquisition process";
       // acquisitor->acquire();

        // Check Synchronizer
		if(debug==1) { printf(" - DEBUG - loop 3\n"); }
        dtkInfo() << "QDateTime from application: " << acquisitor->getSynchronizer().getDateTime();

        // Display
		if(debug==1) { printf(" - DEBUG - loop 4\n"); }
        dtkTrace() << "Acquisition display";
		if(display==1) { 
			_DisplayCV_colour_slow(640, 480, camera_depth.ColourImage, "image");
			_DisplayCV_gray_slow(640, 480, camera_depth.DepthMap, 50.0f, "depth");
			cv::waitKey(30);
		}
        //view.setAcquisitionImage( g_image );//acquisitor->getImage() );
        view.setAcquisitionImage(acquisitor->getImage());
        
        //! DataFlowWriter
        //QList< QSharedPointer< supAbstractData > > dataFlow;
       // dataFlow.push_back(depth);//acquisitor->getDepth());
       // dataFlow.push_back(g_image);//acquisitor->getImage());
	  
		
        // Inputs
		if(debug==1) { printf(" - DEBUG - loop 5\n"); }
        dtkTrace() << "DataFlowWriter inputs";
        data_flow_writer->setSynchronizer(acquisitor->getSynchronizer());
        //data_flow_writer->setDataFlow( dataFlow );
		if(debug==1) { printf(" - DEBUG - loop 6\n"); }
		//data_flow_writer->setDataFlowDepth(depthraw);
		if(debug==1) { printf(" - DEBUG - loop 7\n"); }
        data_flow_writer->setFilePath(QFile(argv[1]));

        // Specific parameters
		if(debug==1) { printf(" - DEBUG - loop 8\n"); }
        dtkTrace() << "DataFlowWriter specific parameters";
        data_flow_writer->setSpecificParameters( specific_data_flow_writer_parameters );

        // Process
		if(debug==1) { printf(" - DEBUG - loop 9\n"); }
        dtkTrace() << "DataFlowWriter process";
       // data_flow_writer->writeDataFlow();

		if(debug==1) { printf(" - DEBUG - loop 10\n"); }
        application.processEvents();
    }
    
    if(debug==1) { printf(" - DEBUG - release\n"); }
	RELEASE_ASUS_READER();
    //reader.release();
//    depth.Release();
//	scriptNode.Release();
//	context.Release();

	if(debug==1) { printf(" - DEBUG - more release\n"); }
    dtkPluginManager::instance()->uninitialize();
	
	if(debug==1) { printf(" - DEBUG - end\n"); }
    return 0;
}
*/
