/*
 * MultipleSignature.h
 *
 *	Info
 *	Container class for SignatureInterface
 *
 *
 *
 *  Created on: Dec 16, 2013
 *      Author: sbak
 */

#ifndef MULTIPLESIGNATURE_H_
#define MULTIPLESIGNATURE_H_

#include <SignatureInterface.h>
#include <common.h>
#include <typeinfo>

#define MS_TAG "_s"

class MultipleSignature: public SignatureInterface {

	std::vector<SignatureInterface*> signatures;

public:

	//SignatureInterface
	MultipleSignature();
	virtual ~MultipleSignature();

	std::string getID();								/* returns ID of signature */
	float getDistance(SignatureInterface* signature);	/* gets distance between signatures */
	void save(std::string filename);					/* saves signature */
	bool load(std::string filename);					/* loads signature */
	std::vector<float> serialize();						/* serialize to a vector */
	IplImage* getDisplayImage();						/* gets Image which should be displayed to the end user */
	IplImage* getDebugImage();							/* gets Image with drawn signature */
	std::string getSource();							/* gets link to the source of the signature */
	void display(IplImage* img, CvRect roi);			/* draws signature in roi region */

	/************* Extensions *************/
	static bool exists(std::string filename);
	void add(SignatureInterface* signature);
};

#endif /* MULTIPLESIGNATURE_H_ */
