/*
 * SignatureInterface.h
 *
 *  Created on: May 14, 2013
 *      Author: sbak
 */

#ifndef SIGNATUREINTERFACE_H_
#define SIGNATUREINTERFACE_H_

#include <vector>
#include <string>
#include <opencv2/core/types_c.h>

class SignatureInterface {
public:

	virtual ~SignatureInterface(){};

	virtual std::string getID() = 0; /* returns ID of signature */
	virtual float getDistance(SignatureInterface* signature) = 0;	/* gets distance between signatures */
	virtual void save(std::string filename) = 0;	/* saves signature */
	virtual bool load(std::string filename) = 0;	/* loads signature */
	virtual std::vector<float> serialize() = 0;	/* serialize to a vector */
	virtual IplImage* getDisplayImage() = 0;	/* gets Image which should be displayed to the end user */
	virtual IplImage* getDebugImage() = 0;	/* gets Image with drawn signature */
	virtual std::string getSource() = 0;	/* gets link to the source of the signature */
	virtual void display(IplImage* img, CvRect roi) = 0; /* draws signature in roi region */
};


#endif /* SIGNATUREINTERFACE_H_ */
