/*
 * database.h
 *
 *  Created on: Feb 25, 2013
 *      Author: sbak
 */

#ifndef DATABASE_H_
#define DATABASE_H_

#include <stdio.h>
#include <string>

#include "SignatureInterface.h"
#include "SignatureFactory.h"

//QT library
#include <QDir>

class retrievedElement {

public:
	retrievedElement(int _dataIndex, float distance){
			dataIndex = _dataIndex;
			distanceToQuery = distance;
	};

	int dataIndex;
	float distanceToQuery;

	retrievedElement(const retrievedElement& copy){
		dataIndex = copy.dataIndex;
		distanceToQuery = copy.distanceToQuery;
	};

	static bool compare(retrievedElement a, retrievedElement b){
		return a.distanceToQuery < b.distanceToQuery;
	}
};

class database {

	std::string ID;
	std::vector<SignatureInterface*> data;
	std::vector<retrievedElement> retrievedData;

	bool loadEntity(std::string);

public:

	database(std::string ID);
	database(const database& db);
	virtual ~database();

	std::string getID() {return ID;};
	SignatureInterface* getResult(uint rank);
	int getRank(SignatureInterface* sig);
	int size();
	bool load(QDir dir);
	void query(SignatureInterface* sig);

	/*
	 * returns
	 * vector[0] - nAUC value
	 * vector[1], vector[2], ..., vector[size] - CMC values
	 */
	std::vector<float> evaluate(database& queries);

};
#endif /* DATABASE_H_ */
