#ifndef SUPABSTRACTDATACALIBRATION_P_H
#define SUPABSTRACTDATACALIBRATION_P_H

// SUP
#include "supAbstractData_p.h"

// OpenCV
#include <opencv2/core/core.hpp>

class supAbstractDataCalibration;

////////////////////////////////////////////////////
// supAbstractDataCalibrationPrivate interface
////////////////////////////////////////////////////

class DTKCORE_EXPORT supAbstractDataCalibrationPrivate : public supAbstractDataPrivate
{
public:
    supAbstractDataCalibrationPrivate(supAbstractDataCalibration *q = 0) :
        supAbstractDataPrivate(q),
        referentialName("Default"),
        intrinsicMatrix(cv::Mat_<double>::zeros(4,4)),
        extrinsicMatrix(cv::Mat_<double>::zeros(4,4)),
        distortionMatrix(cv::Mat_<double>::zeros(4,4)) {}
    supAbstractDataCalibrationPrivate(const supAbstractDataCalibrationPrivate& other) :
        supAbstractDataPrivate(other),
        referentialName(other.referentialName),
        intrinsicMatrix(other.intrinsicMatrix),
        extrinsicMatrix(other.extrinsicMatrix),
        distortionMatrix(other.distortionMatrix) {}

public:
    virtual ~supAbstractDataCalibrationPrivate(void) { }

public:
    QString referentialName;

    cv::Mat intrinsicMatrix;
    cv::Mat extrinsicMatrix;
    cv::Mat distortionMatrix;
};

////////////////////////////////////////////////////
// supAbstractDataCalibration protected constructors
////////////////////////////////////////////////////

DTK_IMPLEMENT_PRIVATE(supAbstractDataCalibration, supAbstractData)

#endif
