#ifndef SUPABSTRACTDATASTREAM_P_H
#define SUPABSTRACTDATASTREAM_P_H

#include <dtkCore/dtkAbstractData_p.h>
#include <supCore/supAbstractDataCalibration.h>


class supAbstractDataStream;

class supAbstractDataStreamPrivate : public dtkAbstractDataPrivate
{
public:
    supAbstractDataStreamPrivate(supAbstractDataStream *q = 0) : dtkAbstractDataPrivate(q), device("Default"), streamName("Default") { }
    supAbstractDataStreamPrivate(const supAbstractDataStreamPrivate& other) : dtkAbstractDataPrivate(other), url(other.url), device(other.device), streamName(other.streamName), camera(other.camera) { }

public:
    virtual ~supAbstractDataStreamPrivate(void) {}

public:
    QUrl url;
    QString device;

    QString streamName;
    // SUP Abstract Data Calibration
    supAbstractDataCalibration camera;//Initialise it to NULL

};

DTK_IMPLEMENT_PRIVATE(supAbstractDataStream, dtkAbstractData)

#endif
