#ifndef SUPABSTRACTPROCESS_H
#define SUPABSTRACTPROCESS_H

#include <dtkCore/dtkAbstractProcess.h>
#include <supCore/synchronizer.h>

#include "supCoreExport.h"

class supAbstractProcessPrivate;

// /////////////////////////////////////////////////////////////////
// supAbstractProcess interface
// /////////////////////////////////////////////////////////////////

class SUPCORE_EXPORT supAbstractProcess : public dtkAbstractProcess
{
    Q_OBJECT

public:
             supAbstractProcess(void);
             supAbstractProcess(const supAbstractProcess& other);
    virtual ~supAbstractProcess(void);

public:
    void setSynchronizer(const CSynchronizer& sync);
    const CSynchronizer& getSynchronizer() const;

public:
    virtual bool setSpecificParameters(const QVariantMap& parameters);
    const QVariantMap& getSpecificParameters() const;

private:
    DTK_DECLARE_PRIVATE(supAbstractProcess)
};

#endif

