#ifndef SUPABSTRACTPROCESSACQUISITOR_P_H
#define SUPABSTRACTPROCESSACQUISITOR_P_H

#include "supAbstractProcess_p.h"

#include "supAbstractDataStream.h"

#include "supDataImage.h"

class supAbstractProcessAcquisition;

////////////////////////////////////////////////////
// supAbstractProcessAcquisitionPrivate interface
////////////////////////////////////////////////////

class DTKCORE_EXPORT supAbstractProcessAcquisitionPrivate : public supAbstractProcessPrivate
{
    public:
        supAbstractProcessAcquisitionPrivate(supAbstractProcessAcquisition *q = 0) : supAbstractProcessPrivate(q) {}
        supAbstractProcessAcquisitionPrivate(const supAbstractProcessAcquisitionPrivate& other) : supAbstractProcessPrivate(other), stream(other.stream), image(other.image), depth(other.depth) {}

    public:
        virtual ~supAbstractProcessAcquisitionPrivate(void) {}

    public: // Input
        QSharedPointer< supAbstractDataStream > stream;

    public: // Output
        QSharedPointer< supDataImage > image;
        QSharedPointer< supDataImage > depth;
};

////////////////////////////////////////////////////
// supAbstractProcessAcquisition protected constructors
////////////////////////////////////////////////////

DTK_IMPLEMENT_PRIVATE(supAbstractProcessAcquisition, supAbstractProcess)

#endif
