#ifndef SUPABSTRACTPROCESSBLOBGENERATOR_H
#define SUPABSTRACTPROCESSBLOBGENERATOR_H

#include <supCore/supAbstractProcess.h>

#include "supCoreExport.h"

class supDataImage;
class supDataBlob;

class supAbstractProcessBlobsGenerationPrivate;

// /////////////////////////////////////////////////////////////////
// supAbstractProcessBlobsGeneration interface
// /////////////////////////////////////////////////////////////////

class SUPCORE_EXPORT supAbstractProcessBlobsGeneration : public supAbstractProcess
{
    Q_OBJECT

public:
             supAbstractProcessBlobsGeneration(void);
             supAbstractProcessBlobsGeneration(const supAbstractProcessBlobsGeneration& other);
    virtual ~supAbstractProcessBlobsGeneration(void);

public: // Input
    void setSegmentationImage( QSharedPointer< supDataImage >& i_segmentation );

public: // Common parameters
    void setMinArea(int i_minArea);
    void setMinDimension(int i_minDimension);

public: // Process
    virtual bool generate(void) = 0;

public: // Output
    QList< QSharedPointer< supDataBlob > >& getBlobs(void);

private:
    DTK_DECLARE_PRIVATE(supAbstractProcessBlobsGeneration)
};

#endif

