#ifndef SUPABSTRACTPROCESSBLOBGENERATOR_P_H
#define SUPABSTRACTPROCESSBLOBGENERATOR_P_H

#include "supAbstractProcess_p.h"

#include "supDataImage.h"

#include "supDataBlob.h"

class supAbstractProcessBlobsGeneration;

////////////////////////////////////////////////////
// supAbstractProcessBlobsGenerationPrivate interface
////////////////////////////////////////////////////

class DTKCORE_EXPORT supAbstractProcessBlobsGenerationPrivate : public supAbstractProcessPrivate
{
    public:
        supAbstractProcessBlobsGenerationPrivate(supAbstractProcessBlobsGeneration *q = 0) : supAbstractProcessPrivate(q), minArea(2000), minDimension(50) {}
        supAbstractProcessBlobsGenerationPrivate(const supAbstractProcessBlobsGenerationPrivate& other) : supAbstractProcessPrivate(other), segmentation_image(other.segmentation_image), blobs(other.blobs), minArea(other.minArea), minDimension(other.minDimension) {}

    public:
        virtual ~supAbstractProcessBlobsGenerationPrivate(void) {}

    public: // Input
        QSharedPointer< supDataImage > segmentation_image;

    public: // Common parameters
        int minArea;
        int minDimension;

    public: // Output
        QList< QSharedPointer< supDataBlob > > blobs;
};

////////////////////////////////////////////////////
// supAbstractProcessBlobsGeneration protected constructors
////////////////////////////////////////////////////

DTK_IMPLEMENT_PRIVATE(supAbstractProcessBlobsGeneration, supAbstractProcess)

#endif
