#ifndef SUPABSTRACTPROCESSDATAFLOWWRITER_H
#define SUPABSTRACTPROCESSDATAFLOWWRITER_H

#include "supAbstractProcess.h"

#include "supCoreExport.h"

#include "supAbstractData.h"
#include "supDataActor.h"

#include <QFile>
#include <QDomElement>
#include <QDomDocument>

class supAbstractProcessDataFlowWriterPrivate;

// /////////////////////////////////////////////////////////////////
// supAbstractProcessDataFlowWriter interface
// /////////////////////////////////////////////////////////////////

class SUPCORE_EXPORT supAbstractProcessDataFlowWriter : public supAbstractProcess
{
    Q_OBJECT

public:
             supAbstractProcessDataFlowWriter(void);
             supAbstractProcessDataFlowWriter(const supAbstractProcessDataFlowWriter& other);
    virtual ~supAbstractProcessDataFlowWriter(void);

             void setFilePath (const QFile& file);
             const QFile& getFilePath();

             virtual void setDataFlow (const QList< QSharedPointer< supAbstractData > >& dataFlow);
             virtual void setDataFlow (const QSharedPointer< supAbstractData >& dataFlow);

             virtual bool writeDataFlow();
			 
			 // // int buffer_size, camera_type, max_fps;

	bool USE_COLOUR_IMAGE;
	int ALT_buffer_size;
	int ALT_camera_type;
	bool ALT_Record_If_Movement;
			 
private:
             void xmlGen();
             QDomElement setTimeStampElement();

private:
    DTK_DECLARE_PRIVATE(supAbstractProcessDataFlowWriter);
};

class SUPCORE_EXPORT class_writer_param
{
public:
	class_writer_param();
	~class_writer_param();
	
	int construct_buffer_size, construct_camera_type;
	bool no_rgb_recording;
	bool force_ctime;
	int FLIP;
	float maxfps;
	bool record_if_motion, record_period;
	bool SwitchOff; int wantedSwitchOffHour, wantedSwitchOffMinute;
	
	void getDepthWriterPluginParameters(std::string commonPath);
	void read_from_args(int argc, char **argv);
	void GetCurrentTime(QDateTime &new_datetime);
	void Print();
};

#endif

