#ifndef SUPABSTRACTPROCESSDEPTHSEGMENTATION_H
#define SUPABSTRACTPROCESSDEPTHSEGMENTATION_H

#include "supCoreExport.h"

#include <supCore/supAbstractProcess.h>
#include "supDataImage.h"
#include "synchronizer.h"

#include <opencv2/core/core.hpp>
#include <list>
#include <string>

//#include <QDateTime>

#include "supDataPhysicalObject.h"

/*struct SimpleRect {
    int left, top, right, bottom;
    void setRect(const int left_, const int top_, const int right_, const int bottom_) {
        left = left_; top = top_; right = right_; bottom = bottom_;
    };

};*/

class supAbstractDataCalibrationWithDepth;
class supDataContext;

class supAbstractProcessDepthSegmentationPrivate;

class SUPCORE_EXPORT supAbstractProcessDepthSegmentation : public supAbstractProcess
{
    Q_OBJECT

public:
             supAbstractProcessDepthSegmentation(void);
             supAbstractProcessDepthSegmentation(const supAbstractProcessDepthSegmentation& other);
    virtual ~supAbstractProcessDepthSegmentation(void);


public:

    //virtual void detectObjects ( const cv::Mat & rgbImg, const cv::Mat & depthImg, const uint64_t timestamp, PhysicalObjs & detectedObjs);
    virtual void setColorImg( const supDataImage & rgbImg);
    virtual void setDepthImg( const supDataImage & depthImg);
    virtual void setParameterFile( const std::string &fileName, const std::string commonPath="");

    virtual void setCalibrationWithDepth( supAbstractDataCalibrationWithDepth * pCalib);
    virtual void computeEquationPlan( const supDataContext * pContext);

    
    virtual void getPhysicalObjs( PhysicalObjs & physicalObjs);
    virtual void getBackgroundDepthMap( cv::Mat & bgDepthMap);

    virtual void adjustBoundingBox3d( PhysicalObjs & physicalObjs);
    virtual void saveBackground( const std::string & fileName );
    
private:
    DTK_DECLARE_PRIVATE(supAbstractProcessDepthSegmentation)
};

#endif

