/* supAbstractProcessFeetDetection.h ---
 *
 * Author: %Author%
 */

/* Commentary:
 *
 */

/* Change log:
 *
 */

#ifndef SUPABSTRACTPROCESSFEETDETECTION_H
#define SUPABSTRACTPROCESSFEETDETECTION_H

#include <supCore/supAbstractProcess.h>

#include "supCoreExport.h"
#include "supDataActor.h"

class supAbstractProcessFeetDetectionPrivate;

// /////////////////////////////////////////////////////////////////
// supAbstractProcessFeetDetection interface
// /////////////////////////////////////////////////////////////////

class SUPCORE_EXPORT supAbstractProcessFeetDetection : public supAbstractProcess
{
    Q_OBJECT

public:
             supAbstractProcessFeetDetection(void);
             supAbstractProcessFeetDetection(const supAbstractProcessFeetDetection& other);
    virtual ~supAbstractProcessFeetDetection(void);

public:
    virtual supAbstractProcessFeetDetection *clone(void); // If your class is pure virtual you need to set this method to pure virtual too! 

public:
    supAbstractProcessFeetDetection& operator = (const supAbstractProcessFeetDetection& other);

protected:
   virtual void copy(const dtkAbstractObject& other);

public:
   QString identifier(void) const;

public:

   virtual void init ();
   virtual void setParameterFile ( std::string fileName );

   virtual void setActorList (const std::list <QSharedPointer <const supDataActor > > actors);

public:

   virtual std::map <int, std::pair <std::list <cv::Point3f>*, std::list <cv::Point3f>* > > getLegsPoints ();
   virtual std::map <int, std::pair <cv::Point3f, cv::Point3f> > getFeetPositions ();
   virtual std::map <int, double> getSpeed();

public:
    // Methods you want to overload from dtkAbstractdtkAbstractProcess

   // Try to sort in the alphabetical order

public:

   virtual void computeFeetPositions(std::vector<double> l_eqCoef);
   virtual void computeSpeeds(float frameRate);

private:
    DTK_DECLARE_PRIVATE(supAbstractProcessFeetDetection);
};

Q_DECLARE_METATYPE(supAbstractProcessFeetDetection)  // If your class is pure virtual, you cannot register to QMetatype.
Q_DECLARE_METATYPE(supAbstractProcessFeetDetection*) // Hence, you need to comment theses lines.

#endif

