#ifndef SUPVIEWEVENTTIMELINE_P_H
#define SUPVIEWEVENTTIMELINE_P_H

#include <dtkCore/dtkAbstractView_p.h>


class QGraphicsScene;
class QGraphicsView;

class QGraphicsPixmapItem;
class QGraphicsItemGroup;

class supViewEventTimeline;

class supViewEventTimelinePrivate : public dtkAbstractViewPrivate
{
public:
    supViewEventTimelinePrivate(supViewEventTimeline *q = 0) : dtkAbstractViewPrivate(q), image(new QGraphicsPixmapItem)
    {
        view.setRenderHint(QPainter::Antialiasing, true);
        view.setScene(&scene);

        scene.addItem(image);
    }
    supViewEventTimelinePrivate(const supViewEventTimelinePrivate& other) : dtkAbstractViewPrivate(other), image(other.image)
    {
        view.setRenderHint(QPainter::Antialiasing, true);
        view.setScene(&scene);

        scene.addItem(image);
    }

public:
    virtual ~supViewEventTimelinePrivate(void)
    {
        scene.clear();
    }

public:
    QGraphicsScene scene;
    QGraphicsView  view;

    QGraphicsPixmapItem* image;
    QList< QGraphicsItem* > blobs;
};

DTK_IMPLEMENT_PRIVATE(supViewEventTimeline, dtkAbstractView)

#endif

