#ifndef SYNCHRONIZER_H
#define SYNCHRONIZER_H

#include "supCoreExport.h"

#include <QDateTime>

class SUPCORE_EXPORT CSynchronizer {
public:
    CSynchronizer();
    ~CSynchronizer();
    
    CSynchronizer& operator = (const CSynchronizer& other);

    void setDateTime( const QDateTime & dateTime) ;
    void setFrameNumber( unsigned int i_frameNumber) ;

    unsigned int getYear       () const;
    unsigned int getMonth      () const;
    unsigned int getDay        () const;
    unsigned int getHour       () const;
    unsigned int getMinute     () const;
    unsigned int getSecond     () const;
    unsigned int getMillisecond() const;
    qint64 toMSecsSinceEpoch      () const;
    QDateTime getDateTime() const;
    unsigned int getFrameNumber() const;
    QString  getCameraName () const;
    bool operator!=( const CSynchronizer& ts ) const;
    bool operator==( const CSynchronizer& ts ) const;
    bool operator<( const CSynchronizer& ts ) const;

private:
    QDateTime _dateTime;
    unsigned int _frameNumber;
};

#endif
